/* 
$Id: specific.js 404 2010-03-30 12:42:53Z rshansen $  (Updated by svn) 
*/
/** This array holds all information related to supported J1939 SPNs. It must be in sync. 
*	with the table in the C source code for M2500 - Unfortunately this has to be done 
*	manually until we have time to invent an automated solution. The array only holds the 
*	SPNs that can be used to program alarms against.*/
var spns = []; 
spns.push( new Array(100, 	"Engine oil pressure", "bar", 1, 0, 100)  );
spns.push( new Array(110, 	"Engine coolant temperature", "&#176;C", 1, -40, 210)  );
spns.push( new Array(190, 	"Engine speed", "rpm", 0, 0, 8030)  );
spns.push( new Array(29, 	"Secondary throttle position", "%", 1, 0, 1000)  );
spns.push( new Array(91, 	"Primary throttle position", "%", 1, 0, 1000)  );
spns.push( new Array(92, 	"Engine load", "%", 01, 0, 250)  );
spns.push( new Array(168, 	"Battery voltage", "V", 1, 0, 9999)  );
spns.push( new Array(102, 	"Intake manifole #1 pressure", "bar", 1, 0, 50)  );
spns.push( new Array(105, 	"Intake manifole #1 temperature", "&#176;C", 0, -40, 210)  );
spns.push( new Array(106, 	"Air inlet pressure", "bar", 1, 0, 50)  );
spns.push( new Array(173, 	"Exhaust gas temperature", "&#176;C", 0, -273, 1735)  );
spns.push( new Array(94, 	"Fuel pressure", "bar", 1, 0, 100)  );
spns.push( new Array(101, 	"Crankcase pressure", "bar", 1, -2500, 2500)  );
spns.push( new Array(109, 	"Coolant pressure", "bar", 1, 0, 50)  );
spns.push( new Array(111, 	"Coolant level", "%", 1, 0, 1000)  );
spns.push( new Array(3676, 	"Aftercooler coolant level", "%", 1, 0, 1000)  );
spns.push( new Array(174, 	"Fuel temperature", "&#176;C", 0, -40, 210)  );
spns.push( new Array(1203, 	"Aftercooler coolant presseure", "bar", 1, 0, 100)  );
spns.push( new Array(2433, 	"Left manifold exhaust gas temperature", "&#176;C", 0, -273, 1735)  );	
spns.push( new Array(2434, 	"Right manifold exhaust gas temperature", "&#176;C", 0, -273, 1735)  );	
spns.push( new Array(95, 	"Fuel filter differential pressure", "bar", 1, 0, 50)  );
spns.push( new Array(96, 	"Fuel level", "%", 1, 0, 1000)  );
spns.push( new Array(99, 	"Oil filter differential pressure", "bar", 1, 0, 125)  );
spns.push( new Array(1382, 	"Fuel pre-filter pressure", "bar", 1, 0, 50)  );
spns.push( new Array(1208, 	"Oil pre-filter pressure", "bar", 1, 0, 100)  );
spns.push( new Array(127, 	"Transmission pressure", "bar", 1, 0, 400)  );
spns.push( new Array(177, 	"Transmission temperature", "&#176;C", 0, -273, 1735)  );
var spn_ch_options = null;
function get_spn_ch_options(){
if( spn_ch_options == null ){
spn_ch_options = ""
for( var n=0; n<spns.length; n++ ){
if( n ){ 
spn_ch_options += "/"; 
}
spn_ch_options += "SPN " + spns[n][0] + " (" + spns[n][1] + ")"; 
}
}
return spn_ch_options;
}
function trg_ch_max_by_al_idx(al_idx){
DBG("trg_ch_max_by_al_idx, arg[0]=["+ al_idx +"]");
e = findElementOnActPageById( "INT8_AL_" + al_idx + "_INP_SRC"); 
if( e != 0 ){
DBG("Got it[" + e.getId() + " = " + e.getValue() + "]" );
e.tagReload(); 
switch( Number(e.getValue()) ){
case 0: return String(8); 
case 1: return String(1); 
case 2:	return String(9); 
case 3:	return String(3); 
}
}
return String(0);
}
function trg_operator_by_al_idx(al_idx){
DBG("trg_operator_by_al_idx, arg[0]=["+ al_idx +"]");
e = findElementOnActPageById( "INT8_AL_" + al_idx + "_INP_SRC"); 
if( e != 0 ){
DBG("Got it[" + e.getId() + " = " + e.getValue() + "]" );
e.tagReload();
if( Number(e.getValue()) == 2){ 
return String("na/na");
}
}
return String(">=/<=");
}
function trg_operator_hide_by_al_idx(al_idx){
DBG("trg_operator_hide_by_al_idx, arg[0]=["+ al_idx +"]");
e = findElementOnActPageById( "INT8_AL_" + al_idx + "_INP_SRC"); 
if( e != 0 ){
DBG("Got it[" + e.getId() + " = " + e.getValue() + "]" );
e.tagReload();
if( Number(e.getValue()) == 2){ 
return String("1");
}
}
return String("0");
}
function trg_lvl_type_by_al_idx(al_idx){
DBG("trg_lvl_type_by_al_idx, arg[0]=["+ al_idx +"]");
e = findElementOnActPageById( "INT8_AL_" + al_idx + "_INP_SRC"); 
if( e != 0 ){
DBG("Got it[" + e.getId() + " = " + e.getValue() + "]" );
e.tagReload();
if( Number(e.getValue()) == 2){ 
trg_val_into_range_by_al_idx(al_idx); 
return String("list");
}
else if( Number(e.getValue()) == 0){ 
trg_val_into_range_by_al_idx(al_idx); 
return String("sint");
}
else if( Number(e.getValue()) == 3){ 
trg_val_into_range_by_al_idx(al_idx); 
return String("sint");
}		
}
return String("int");
}
function trg_lvl_options_by_al_idx(al_idx){
DBG("trg_lvl_type_by_al_idx, arg[0]=["+ al_idx +"]");
e = findElementOnActPageById( "INT8_AL_" + al_idx + "_INP_SRC"); 
if( e != 0 ){
DBG("Got it[" + e.getId() + " = " + e.getValue() + "]" );
e.tagReload();
if( Number(e.getValue()) == 2){ 
return String("Open/Closed");
}
}
return String("");
}
function trg_lvl_min_by_al_idx(al_idx){
DBG("trg_lvl_min_by_al_idx, args[0]=["+ al_idx +"]");
eSrc = findElementOnActPageById("INT8_AL_" + al_idx + "_INP_SRC"); 
eCh  = findElementOnActPageById("INT8_AL_" + al_idx + "_INP_CH"); 
if( (eSrc != 0) && (eCh != 0) ){
ch = Number(eCh.getValue()) + 1;
DBG("Got it[" + eSrc.getId() + " = " + eSrc.getValue() + "]" );
DBG("Got it[" + eCh.getId() + " = " + ch + "]" );
eCh.tagReload(); 
if( Number(eSrc.getValue())==0 ){ 
e = findElementById("INT_AIN_" + ch +  "_MIN_SCALE");			
if( e != 0 ){
DBG("Got it[" + e.getId() + " = " + e.getValue() + "]" );
return String( e.getValue() );
}
}
else
if( Number(eSrc.getValue())==3 ){ 
return String(spns[ch-1][4]);  
}	
}
return String(0);
}
function trg_lvl_max_by_al_idx(al_idx){
var ret=9999;
DBG("trg_lvl_max_by_al_idx, args[0]=["+ al_idx +"]");
eSrc = findElementOnActPageById("INT8_AL_" + al_idx + "_INP_SRC"); 
eCh  = findElementOnActPageById("INT8_AL_" + al_idx + "_INP_CH"); 
if( (eSrc != 0) && (eCh != 0) ){
ch = Number(eCh.getValue()) + 1;	
DBG("Got it[" + eSrc.getId() + " = " + eSrc.getValue() + "]" );
DBG("Got it[" + eCh.getId() + " = " + ch + "]" );
eCh.tagReload(); 
if( Number(eSrc.getValue())==0 ){ 
e = findElementById("INT_AIN_" + ch +  "_MAX_SCALE");
if( e != 0 ){
DBG("Got it[" + e.getId() + " = " + e.getValue() + "]" );
ret =  e.getValue();
}
}
else
if( Number(eSrc.getValue())==2 ){ 
ret = 1; 
}
else
if( Number(eSrc.getValue())==3 ){ 
ret = spns[ch-1][5];  
}
}
return String(ret);
}
function trg_val_into_range_by_al_idx(al_idx){
var max=9999;
DBG("trg_val_into_range_by_al_idx, args[0]=["+ al_idx +"]");
var eSrc = findElementOnActPageById("INT8_AL_" + al_idx + "_INP_SRC"); 
var eCh  = findElementOnActPageById("INT8_AL_" + al_idx + "_INP_CH"); 
var eLvl  = findElementOnActPageById("INT_AL_" + al_idx + "_INP_TRG_LVL"); 
if( (eSrc != 0) && (eCh != 0) && (eLvl != 0) ){
ch = Number(eCh.getValue()) + 1;	
DBG("Got it[" + eSrc.getId() + " = " + eSrc.getValue() + "]" );
DBG("Got it[" + eCh.getId() + " = " + ch + "]" );
eCh.tagReload(); 
if( Number(eSrc.getValue())==0 ){ 
e = findElementById("INT_AIN_" + ch +  "_MAX_SCALE");
if( e != 0 ){
DBG("Got it[" + e.getId() + " = " + e.getValue() + "]" );
max =  e.getValue();
}
}
else
if( Number(eSrc.getValue())==2 ){ 
max=1;
if( eLvl.value > max ){
eLvl.value = max;
}
}
}
}
function trg_unit_by_al_idx(al_idx){
DBG("trg_unit_by_al_idx, args[0]=["+ al_idx +"]");
eSrc = findElementOnActPageById("INT8_AL_" + al_idx + "_INP_SRC"); 
eCh  = findElementOnActPageById("INT8_AL_" + al_idx + "_INP_CH"); 
if( (eSrc != 0) && (eCh != 0) ){
DBG("Got it[" + eSrc.getId() + " = " + eSrc.getValue() + "]" );
DBG("Got it[" + eCh.getId() + " = " + eCh.getValue() + "]" );
eCh.tagReload(); 
if( Number(eSrc.getValue())==0 ){ 
ch = Number(eCh.getValue())+1;
e = findElementById("STR_AIN_"    + ch +  "_UNIT");
eDp = findElementById("BOOL_AIN_" + ch +  "_SHOW_DP");
if( e != 0 ){
var uStr = "";
DBG("Got it[" + e.getId() + " = " + e.getValue() + "]" );
uStr += String( e.getValue() );
if( eDp != 0 ){
if( eDp.getValue()>0 ){
uStr += " (One decimal point)";
}
}
return uStr;
}
}
else
if( Number(eSrc.getValue())==1 ){ 
return "RPM";
}		
else
if( Number(eSrc.getValue())==3 ){ 
var uStr = "";
uStr += String( spns[ch-1][2] ); 
if( spns[ch-1][3]==1 ){ 
uStr += " (One decimal point)";
}
return uStr; 
}		
}
return String("");
}
function hide_lube_interval_parms(){
if( if_cfg_element_is_equal_to_val("BOOL_SYS_LUBE_ENABLED, 0") == "1" ){
return String("1");
}
if( if_cfg_element_is_equal_to_val("INT8_SYS_LUBE_MODE, 1") == "1" ){
return String("1");
}	
return String("0");	
}
function ch_options_by_al_idx(al_idx){
DBG("ch_options_by_al_idx, arg[0]=["+ al_idx +"]");
e = findElementOnActPageById( "INT8_AL_" + al_idx + "_INP_SRC"); 
if( e != 0 ){
DBG("Got it[" + e.getId() + " = " + e.getValue() + "]" );
e.tagReload(); 
switch( Number(e.getValue()) ){
case 0: return "1/2/3/4/5/6/7/8"; 
case 1: return "Pick-up 1"; 
case 2:	return "1/2/3/4/5/6/7/8/9"; 
case 3: return get_spn_ch_options();
}
}
return String(0);
}
function hide_lube_interval_parms(){
if( if_cfg_element_is_equal_to_val("BOOL_SYS_LUBE_ENABLED, 0") == "1" ){
return String("1");
}
if( if_cfg_element_is_equal_to_val("INT8_SYS_LUBE_MODE, 1") == "1" ){
return String("1");
}	
return String("0");	
}
function if_alarm_disabled(args){
aargs = String(args).split(","); 
alno = Number(aargs[0]);
return Number(if_cfg_element_is_equal_to_val('INT8_AL_' + alno + '_IS_ENABLED,0'));
}
